#ifndef __VRMLGEN_H_
#define __VRMLGEN_H_
#include <vector.h>
#include <stdio.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <math.h>

#define IP 0

#define DEST_HOST "altavista.digital.com"
#define DEST_PORT 80
#define BASE_STRING "GET /cgi-bin/query?pg=c9&c9fmt=j&q="
#define TOPIC_SEARCH "<PARAM NAME=TOPICS VALUE=\""
#define TOPIC_LINK " <PARAM NAME=LINKS VALUE=\""

#define VRML_HEADER "#VRML V2.0 utf8\n"\
                     "#\n"\
                     "#This VRML code is automatically generated from \n"\
                     "#the search query by vrmlgen.cgi.\n"\
                     "#\n"\
                     "#copywright(C) Carl Shimer harshaw@wpi.edu\n"\
                     "#\n"

#define TRUE 1
#define FALSE 0

		     const float color_table[][3] = {{0,0,0.5},
						     {0,0,0.7},
						     {0,0,1.0},
						     {0,0.5,0},
						     {0,0.7,0},
						     {0,1.0,0},
						     {0.5,0,0},
						     {0.7,0,0},
						     {1.0,0,0}};
						     


#ifndef PI
#define PI 3.1415257
#endif

class searchpair {

 private:
  char topicptr[50];
  int priority;
public:


  
  searchpair(char* string,int pri)
    {
      strcpy(topicptr,string);
      priority = pri;
    }

  searchpair()
    {
    }

  ~searchpair()
    {

    }
  
  inline void print()
    {
      cout << topicptr << " " << priority << " ";
    }

  inline void insert(char* string,int pri)
    {
      strcpy(topicptr,string);
      priority = pri;

    }
  
  inline void insert(searchpair search)
    {
      strcpy(topicptr,search.topicptr);
      priority = search.priority;
    }
  inline char* name()
    {
      return topicptr;
    }
  inline int get_priority()
    {
      return priority;
    }
  
};


class linkrelations {


 public:
  int relation1;
  int relation2;
  bool valid_flag;

  
  
  linkrelations(int one,int two)
    {
      relation1 = one;
      relation2 = two;
      valid_flag = TRUE;
    }
  
  linkrelations() {valid_flag = TRUE;}


  inline void print()
    {
      cout << relation1 << " " << relation2 << " ";
    }
  inline bool validity()
    {
      return valid_flag;
    }
  inline void invalidate()
    {
      valid_flag = FALSE;
    }
  
};

class SFColor;

class topic {

 public:
  int index;
  searchpair topiclist[50];
  bool valid_flag;
  float coords[3];
  bool drawn_children;

  topic() {
    index = 0;
    valid_flag = TRUE;
    drawn_children = FALSE;
  }
  

  void insert(char*);

  

  inline void print()
    {
      for(int i=0;i<index;i++)
	topiclist[i].print();
      cout << endl;
    }

  inline void insert_element(searchpair insearch)
    {
      topiclist[index++].insert(insearch);
    }
  inline int size()
    {
      return index;
    }
  inline char* return_name(int i)
    {
      return topiclist[i].name();
    }
  inline bool validity()
    {
      return valid_flag;
    }
  inline void invalidate()
    {
      valid_flag = FALSE;
    }
  inline bool drawn_children_query()
    {
      return drawn_children;
    }
  inline void invalidate_children()
    {
      drawn_children = TRUE;
    }

  inline void insert_coords(float in1,float in2,float in3)
    {
      coords[0] = in1;
      coords[1] = in2;
      coords[2] = in3;
    }

};


class transform;

class internet_handler {

private:

char filename[100];
topic available_topics[50];
linkrelations available_links[50];
int topic_index,link_index;

public:

int get_socket();
int altavista_io(char*);
void extract_info();


void get_sub_links(vector<int>&,int);
void get_peer_links(vector<int>&,int,int);
transform* gen_level_cone(SFColor,SFColor,int,vector<int>);
int produce_webpage();
transform* gen_cone(topic);
transform* draw_peers(vector<int>,int,int);
int find_node();

internet_handler()
  {
    int i;
    char buffer[11];
    topic_index = 0;
    link_index = 0;



    
    srand(time(NULL));
    for(i=0;i<10;i++)
      buffer[i] = (char)((rand()%9)+48);
    buffer[i] = '\0';
    
    strcat(filename,buffer);
    strcat(filename,".vis");

}

~internet_handler()
  {
  unlink(filename);
    
  }

void insert_link(linkrelations newlink)
  {
    available_links[link_index++] = newlink;
  }

void insert_topic(topic newtopic)
  {
    available_topics[topic_index++] = newtopic;
  }
inline int topic_size()
  {
    return topic_index;
  }
inline int link_size()
  {
    return link_index;
  }

};


#endif /* __VRMLGEN_H_ */























